-- changed class name to entity

require("lib/SECS")
Collider = require ("lib/hardoncollider")
Entity = class:new()


function Entity:init(cx,cy) -- added constructer variables so you can define limitations from outside the class
	self.xspeed = 0
	self.yspeed = 0
	self.h = 32
	self.w = 32
	self.x = cx 
	self.y = cy 
	self.colliding = false
	
    ECI = HC:addRectangle(0,0,32,32) -- ECI stands for  Entity Collision Instance
end

function Entity:draw()
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("fill",self.x - 16,self.y - 16,self.w,self.h) -- Obviously a place holder. I believe the player should be smaller too
	love.graphics.setColor(30,255,30)
	--ECI:draw('fill') THIS IS TO DRAW COLLISION INSTANCE
end

function Entity:update(dt)
	self:processGravity(dt)
	self:processKeys(dt)
	self:processFriction(dt)
	self:processSpeed(dt) 
end

function Entity:processKeys(dt) -- The speeds aren't final yet obviously
	if love.keyboard.isDown( "w" ) == true then
		self.yspeed = -500 --This is not really a jump yet. I should add a bounce.
	end
	if love.keyboard.isDown( "a" ) == true then
		if self.xspeed > -500 then -- Give a max speed
		self.xspeed = self.xspeed - 50 -- The longer pressed, the faster the player will go
		end
	end
	if love.keyboard.isDown( "d" ) == true then
		if self.xspeed < 500 then
		self.xspeed = self.xspeed + 50
		end
	end
	if love.mouse.isDown("l") == true then -- What the fuck should happen??? Up to you Harris. .. I still like the dubstep cannon idea though, to be used as a weapon and as a mode of transportation.
		
	end
end

function Entity:processFriction(dt)
	-- be sure to make a check to see if the player is on a tile eventually. X axis friction shouldn't be applied while in mid air...
	self.xspeed = .95 * self.xspeed -- I should find a better formula for reducing speed.
end

function Entity:processGravity(dt)
	if self.colliding == false then
		if self.yspeed <= 500 then
		self.yspeed = self.yspeed + 20
		end
	end
	if self.colliding == true then
		self.yspeed = 0
	end
end

function Entity:processSpeed(dt)
	ECI:move(self.xspeed * dt, self.yspeed * dt) -- Notice we move the collision instance instead and weld the X and Y to it.
	self.x,self.y = ECI:center()
end
